#include "TestMessageGenerator.h"
#include <cstdlib>
#include <sstream>


std::string SimpleTestMessageGenerator::getNext()
{
	std::stringstream stream;
	stream << "Test Message No." << counter_++;
	return stream.str();
}


void SimpleTestMessageGenerator::reset()
{
	counter_ = 0;
}


LongTestMessageGenerator::LongTestMessageGenerator(const std::size_t size, const char filler)
	: size_{size}
	, filler_{filler}
{}


std::string LongTestMessageGenerator::getNext()
{
	std::stringstream stream;
	stream << "Test Message No." << counter_++;
	while (stream.tellp() < size_)
	{
		stream << filler_;
	}
	return stream.str();
}


void LongTestMessageGenerator::reset()
{
	counter_ = 0;
}


RandomTestMessageGenerator::RandomTestMessageGenerator(const std::size_t size)
	: size_{size}
{}


std::string RandomTestMessageGenerator::getNext()
{
	std::stringstream stream;
	stream << "Test Message No." << counter_++;
	while (stream.tellp() < size_)
	{
		stream << distribution_(generator_);
	}
	return stream.str();
}


void RandomTestMessageGenerator::reset()
{
	counter_ = 0;
	generator_ = std::default_random_engine{};
}
