#include "os/Exception.h"
#include <stdio.h>
#include <cstring>


namespace os
{


	Exception::Exception (const ErrorCode error, const char* file, const std::uint32_t line) noexcept
		: reason_ {}
	{
		std::array<char,64> errorBuffer;
		::snprintf (& reason_ [0],
				    ReasonLength_,
					"%s:%d(%s,%u)",
					::strerror_r(error, &errorBuffer.front(), errorBuffer.size()),
					error,
					file,
					line);
	}

	const char* Exception::what () const noexcept
	{
		return & reason_ [0];
	}


} // namespace os
