#include "os/FileLister.h"
#include <dirent.h>


namespace os
{

FileLister::FileLister(const std::string& pathDirectory)
{
	DIR* directory = nullptr;
	try
	{
		directory = ::opendir (pathDirectory.c_str());
		if (nullptr != directory)
		{
			dirent* entry{nullptr};
			do
			{
				entry = ::readdir(directory);
				if (nullptr != entry)
				{
					std::string name (entry->d_name);
					if (("." != name) && (".." != name))
					{
						list_.push_back(std::move(name));
					}
				}
			}
			while (nullptr != entry);
			::closedir(directory);
			directory = nullptr;
		}
	}
	catch (...)
	{
		if (nullptr != directory)
		{
			::closedir(directory);
			directory = nullptr;
		}
		throw;
	}
}


} // namespace os
