#include "os/FileStatus.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

namespace os {

FileStatus::FileStatus(const std::string& path)
	: status_{std::make_unique<struct stat>()}
	, isOk_{false}
{
	int const ret = ::stat(path.c_str(), status_.get());
	isOk_ = (0 == ret);
}

FileStatus::~FileStatus()
{
	// do nothing
}

bool FileStatus::isOk() const noexcept
{
	return isOk_;
}

std::uint64_t FileStatus::getSize() const noexcept
{
	return isOk_ ? status_->st_size : 0;
}

}
