#ifndef HEADER_OS_MACHINE_ID
#define HEADER_OS_MACHINE_ID

#include <string>

namespace os
{

/**
 * Class that retrieves the machine id of the system.
 */
class MachineId
{
public:
	/**
	 * Constructor that does the retrieving.
	 */
	MachineId();
	/**
	 * Destructor.
	 */
	~MachineId(){}
	MachineId(const MachineId&) = delete;
	MachineId(MachineId&&) = delete;
	MachineId& operator=(const MachineId&) = delete;
	MachineId& operator=(MachineId&&) = delete;
	/**
	 * Supplies the machine is.
	 */
	const std::string& get() const noexcept
	{
		return id_;
	}

private:
	/**
	 * The machine id.
	 */
	std::string id_{};
};

} // namespace os

#endif // HEADER_OS_MACHINE_ID
