#ifndef HEADER_OS_PROCESS_OUTPUT_SCANNER
#define HEADER_OS_PROCESS_OUTPUT_SCANNER


#include <cstdlib>
#include <string>


namespace os
{

	/**
	 * Interface class that specifies a scanner for output of a process.
	 */
	class ProcessOutputScanner
	{
	public:
		/**
		 * Constructor.
		 */
		ProcessOutputScanner () {}
		/**
		 * Destructor.
		 */
		virtual ~ProcessOutputScanner () {}
		/**
		 * The functor that does the scanning.
		 */
		virtual void operator() (const std::string& output) = 0;
	};


}  // namspace os


#endif // HEADER_OS_PROCESS_OUTPUT_SCANNER
