#ifndef HEADER_PROCESS_OUTPUT_SCANNER_DUMMY
#define HEADER_PROCESS_OUTPUT_SCANNER_DUMMY

#include "os/ProcessOutputScanner.h"

namespace os
{

/**
 * Class that specializes a dummy scanner that does nothing.
 */
class ProcessOutputScannerDummy final : public ProcessOutputScanner
{
public:
	using LinesType = std::vector<std::string>;

public:
	/**
	 * Constructor.
	 */
	ProcessOutputScannerDummy():ProcessOutputScanner(){}
	/**
	 * Destructor.
	 */
	~ProcessOutputScannerDummy(){}
	ProcessOutputScannerDummy(const ProcessOutputScannerDummy&) = delete;
	ProcessOutputScannerDummy(ProcessOutputScannerDummy&&) = delete;
	ProcessOutputScannerDummy& operator=(const ProcessOutputScannerDummy&) = delete;
	ProcessOutputScannerDummy& operator=(ProcessOutputScannerDummy&&) = delete;
	/**
	 * Scanner functor that does nothing.
	 */
	void operator()(const std::string& ) noexcept
	{
		// do nothing
	}
};

} // namespace os

#endif // HEADER_PROCESS_OUTPUT_SCANNER_DUMMY
